Index: trunk/NEMO/OPA_SRC/TRA/traadv_cen2.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/traadv_cen2.F90	(revision 873)
+++ trunk/NEMO/OPA_SRC/TRA/traadv_cen2.F90	(revision 888)
@@ -1,11 +1,13 @@
 MODULE traadv_cen2
-   !!==============================================================================
-   !!                       ***  MODULE  traadv_cen2  ***
+   !!======================================================================
+   !!                     ***  MODULE  traadv_cen2  ***
    !! Ocean active tracers:  horizontal & vertical advective trend
-   !!==============================================================================
-   !! History :  8.2  !  01-08  (G. Madec, E. Durand)  trahad+trazad = traadv 
-   !!            8.5  !  02-06  (G. Madec)  F90: Free form and module
-   !!            9.0  !  05-11  (V. Garnier) Surface pressure gradient organization
-   !!            " "  !  06-04  (R. Benshila, G. Madec) Step reorganization
+   !!======================================================================
+   !! History :   8.2  !  01-08  (G. Madec, E. Durand)  trahad+trazad=traadv 
+   !!             8.5  !  02-06  (G. Madec)  F90: Free form and module
+   !!             9.0  !  04-08  (C. Talandier) New trends organization
+   !!             " "  !  05-11  (V. Garnier) Surface pressure gradient organization
+   !!             " "  !  06-04  (R. Benshila, G. Madec) Step reorganization
+   !!             " "  !  06-07  (G. madec)  add ups_orca_set routine
    !!----------------------------------------------------------------------
 
@@ -13,17 +15,21 @@
    !!   tra_adv_cen2 : update the tracer trend with the horizontal and
    !!                  vertical advection trends using a seconder order
+   !!   ups_orca_set : allow mixed upstream/centered scheme in specific
+   !!                  area (set for orca 2 and 4 only)
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and active tracers
    USE dom_oce         ! ocean space and time domain
+   USE sbc_oce         ! surface boundary condition: ocean
+   USE dynspg_oce      ! choice/control of key cpp for surface pressure gradient
+   USE trdmod_oce      ! ocean variables trends
    USE trdmod          ! ocean active tracers trends 
-   USE trdmod_oce      ! ocean variables trends
-   USE flxrnf          !
+   USE closea          ! closed sea
    USE trabbl          ! advective term in the BBL
    USE ocfzpt          !
+   USE sbcrnf          ! river runoffs
+   USE in_out_manager  ! I/O manager
    USE lib_mpp
    USE lbclnk          ! ocean lateral boundary condition (or mpp link)
-   USE in_out_manager  ! I/O manager
    USE diaptr          ! poleward transport diagnostics
-   USE dynspg_oce      ! choice/control of key cpp for surface pressure gradient
    USE prtctl          ! Print control
 
@@ -31,5 +37,9 @@
    PRIVATE
 
-   PUBLIC   tra_adv_cen2   ! routine called by step.F90
+   PUBLIC   tra_adv_cen2    ! routine called by step.F90
+   PUBLIC   ups_orca_set    ! routine used by traadv_cen2_jki.F90
+
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   upsmsk    !: mixed upstream/centered scheme near some straits 
+   !                                                   !  and in closed seas (orca 2 and 4 configurations)
 
    REAL(wp), DIMENSION(jpi,jpj) ::   btr2   ! inverse of T-point surface [1/(e1t*e2t)]
@@ -39,6 +49,6 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header$ 
+   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -118,14 +128,13 @@
       !!
       INTEGER  ::   ji, jj, jk                           ! dummy loop indices
-      REAL(wp) ::                           &
-         zbtr, zta, zsa, zfui, zfvj,        &  ! temporary scalars
-         zhw, ze3tr, zcofi, zcofj,          &  !    "         "
-         zupsut, zupsvt, zupsus, zupsvs,    &  !    "         "
-         zfp_ui, zfp_vj, zfm_ui, zfm_vj,    &  !    "         "
-         zcofk, zupst, zupss, zcent,        &  !    "         "
-         zcens, zfp_w, zfm_w,               &  !    "         "
-         zcenut, zcenvt, zcenus, zcenvs,    &  !    "         "
-         z_hdivn_x, z_hdivn_y, z_hdivn
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zwz, ztrdt, zind   ! 3D workspace 
+      REAL(wp) ::   zta, zsa, zbtr, zhw, ze3tr,       &  ! temporary scalars
+         &          zfp_ui, zfp_vj, zfp_w , zfui  ,   &  !    "         "
+         &          zfm_ui, zfm_vj, zfm_w , zfvj  ,   &  !    "         "
+         &          zcofi , zcofj , zcofk ,           &  !    "         "
+         &          zupsut, zupsus, zcenut, zcenus,   &  !    "         "
+         &          zupsvt, zupsvs, zcenvt, zcenvs,   &  !    "         "
+         &          zupst , zupss , zcent , zcens ,   &  !    "         "
+         &          z_hdivn_x, z_hdivn_y, z_hdivn 
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zwz, ztrdt, zind   ! 3D workspace
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zww, ztrds         !  "      "
       !!----------------------------------------------------------------------
@@ -136,6 +145,10 @@
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~   Vector optimization case'
          IF(lwp) WRITE(numout,*)
-         ! 
-         btr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:) )
+         !
+         upsmsk(:,:) = 0.e0                              ! not upstream by default
+         IF( cp_cfg == "orca" )   CALL ups_orca_set      ! set mixed Upstream/centered scheme near some straits
+         !                                               ! and in closed seas (orca2 and orca4 only)
+         !   
+         btr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:) )        ! inverse of T-point surface
       ENDIF
 
@@ -145,10 +158,10 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zind(ji,jj,jk) =  MAX ( upsrnfh(ji,jj) * upsrnfz(jk),     &  ! changing advection scheme near runoff
-                  &                    upsadv(ji,jj)                     &  ! in the vicinity of some straits
+               zind(ji,jj,jk) = MAX (   &
+                  rnfmsk(ji,jj) * rnfmsk_z(jk),      &  ! near runoff mouths (& closed sea outflows)
+                  upsmsk(ji,jj)                      &  ! some of some straits
 #if defined key_lim3 || defined key_lim2
-                  &                  , tmask(ji,jj,jk)                   &  ! half upstream tracer fluxes
-                  &                  * MAX( 0., SIGN( 1., fzptn(ji,jj)   &  ! if tn < ("freezing"+0.1 )
-                  &                                +0.1-tn(ji,jj,jk) ) ) &
+                  !                                     ! below ice covered area (if tn < "freezing"+0.1 )
+                  , MAX(  0., SIGN( 1., fzptn(ji,jj) + 0.1 - tn(ji,jj,jk) )  ) * tmask(ji,jj,jk)   &
 #endif
                   &                  )
@@ -157,7 +170,8 @@
       END DO
 
-
-      !  Horizontal advective fluxes
-      ! -----------------------------
+      ! I. Horizontal advective fluxes
+      ! ------------------------------
+      !  Second order centered tracer flux at u and v-points
+      ! -----------------------------------------------------
       !                                                ! ===============
       DO jk = 1, jpkm1                                 ! Horizontal slab
@@ -278,6 +292,6 @@
          &                       tab3d_2=sa, clinfo2=            ' Sa: ', mask2=tmask, clinfo3='tra' )
 
-      ! 4. "zonal" mean advective heat and salt transport 
-      ! -------------------------------------------------
+      ! "zonal" mean advective heat and salt transport 
+      ! ----------------------------------------------
 
       IF( ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN
@@ -312,5 +326,5 @@
       ENDIF
 
-      ! 1. Vertical advective fluxes
+      ! 1. Vertical advective fluxes 
       ! ----------------------------
       ! Second order centered tracer flux at w-point
@@ -386,4 +400,65 @@
       !
    END SUBROUTINE tra_adv_cen2
+   
+   
+   SUBROUTINE ups_orca_set
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE ups_orca_set  ***
+      !!       
+      !! ** Purpose :   add a portion of upstream scheme in area where the
+      !!                centered scheme generates too strong overshoot
+      !!
+      !! ** Method  :   orca (R4 and R2) confiiguration setting. Set upsmsk
+      !!                array to nozero value in some straith. 
+      !!
+      !! ** Action : - upsmsk set to 1 at some strait, 0 elsewhere for orca
+      !!----------------------------------------------------------------------
+      INTEGER  ::   ii0, ii1, ij0, ij1      ! temporary integers
+      !!----------------------------------------------------------------------
+      
+      ! mixed upstream/centered scheme near river mouths
+      ! ------------------------------------------------
+      SELECT CASE ( jp_cfg )
+      !                                        ! =======================
+      CASE ( 4 )                               !  ORCA_R4 configuration 
+         !                                     ! =======================
+         !                                          ! Gibraltar Strait
+         ii0 =  70   ;   ii1 =  71
+         ij0 =  52   ;   ij1 =  53   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.50
+         !
+         !                                     ! =======================
+      CASE ( 2 )                               !  ORCA_R2 configuration 
+         !                                     ! =======================
+         !                                          ! Gibraltar Strait
+         ij0 = 102   ;   ij1 = 102
+         ii0 = 138   ;   ii1 = 138   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.20
+         ii0 = 139   ;   ii1 = 139   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.40
+         ii0 = 140   ;   ii1 = 140   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.50
+         ij0 = 101   ;   ij1 = 102
+         ii0 = 141   ;   ii1 = 141   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.50
+         !                                          ! Bab el Mandeb Strait
+         ij0 =  87   ;   ij1 =  88
+         ii0 = 164   ;   ii1 = 164   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.10
+         ij0 =  88   ;   ij1 =  88
+         ii0 = 163   ;   ii1 = 163   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.25
+         ii0 = 162   ;   ii1 = 162   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.40
+         ii0 = 160   ;   ii1 = 161   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.50
+         ij0 =  89   ;   ij1 =  89
+         ii0 = 158   ;   ii1 = 160   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.25
+         ij0 =  90   ;   ij1 =  90
+         ii0 = 160   ;   ii1 = 160   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.25
+         !                                          ! Sound Strait
+         ij0 = 116   ;   ij1 = 116
+         ii0 = 144   ;   ii1 = 144   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.25
+         ii0 = 145   ;   ii1 = 147   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.50
+         ii0 = 148   ;   ii1 = 148   ;   upsmsk( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) = 0.25
+         !
+      END SELECT 
+      
+      ! mixed upstream/centered scheme over closed seas
+      ! -----------------------------------------------
+      CALL clo_ups( upsmsk(:,:) )
+      !
+   END SUBROUTINE ups_orca_set
 
    !!======================================================================
Index: trunk/NEMO/OPA_SRC/TRA/traadv_qck.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/traadv_qck.F90	(revision 873)
+++ trunk/NEMO/OPA_SRC/TRA/traadv_qck.F90	(revision 888)
@@ -14,14 +14,12 @@
    USE oce             ! ocean dynamics and active tracers
    USE dom_oce         ! ocean space and time domain
+   USE dynspg_oce      ! 
+   USE trdmod_oce      ! ocean variables trends
    USE trdmod          ! ocean active tracers trends 
-   USE trdmod_oce      ! ocean variables trends
-   USE flxrnf          !
    USE trabbl          ! advective term in the BBL
-   USE ocfzpt          !
    USE lib_mpp
    USE lbclnk          ! ocean lateral boundary condition (or mpp link)
    USE in_out_manager  ! I/O manager
    USE diaptr          ! poleward transport diagnostics
-   USE dynspg_oce      ! 
    USE prtctl          ! Print control
 
@@ -47,5 +45,5 @@
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header$ 
+   !! $Id$
    !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
Index: trunk/NEMO/OPA_SRC/TRA/tranxt.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 873)
+++ trunk/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 888)
@@ -21,17 +21,16 @@
    USE dom_oce         ! ocean space and time domain variables 
    USE zdf_oce         ! ???
+   USE dynspg_oce      ! surface pressure gradient variables
+   USE trdmod_oce      ! ocean variables trends
+   USE trdmod          ! ocean active tracers trends 
+   USE phycst
+   USE domvvl          ! variable volume
+   USE obctra          ! open boundary condition (obc_tra routine)
    USE in_out_manager  ! I/O manager
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE obctra          ! open boundary condition (obc_tra routine)
-   USE trdmod          ! ocean active tracers trends 
-   USE trdmod_oce      ! ocean variables trends
    USE prtctl          ! Print control
    USE agrif_opa_update
    USE agrif_opa_interp
 
-   USE ocesbc          ! ocean surface boundary condition
-   USE domvvl          ! variable volume
-   USE dynspg_oce      ! surface pressure gradient variables
-   USE phycst
 
    IMPLICIT NONE
@@ -47,5 +46,5 @@
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2006) 
-   !! $Header: /home/opalod/NEMOCVSROOT/NEMO/OPA_SRC/TRA/tranxt.F90,v 1.12 2007/05/25 15:51:50 opalod Exp $ 
+   !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
Index: trunk/NEMO/OPA_SRC/TRA/traqsr.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 873)
+++ trunk/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 888)
@@ -17,9 +17,9 @@
    USE oce             ! ocean dynamics and active tracers
    USE dom_oce         ! ocean space and time domain
+   USE sbc_oce         ! surface boundary condition: ocean
+   USE trc_oce         ! share SMS/Ocean variables
+   USE trdmod_oce      ! ocean variables trends
    USE trdmod          ! ocean active tracers trends 
-   USE trdmod_oce      ! ocean variables trends
    USE in_out_manager  ! I/O manager
-   USE trc_oce         ! share SMS/Ocean variables
-   USE ocesbc          ! thermohaline fluxes
    USE phycst          ! physical constants
    USE prtctl          ! Print control
@@ -46,5 +46,5 @@
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header$ 
+   !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
Index: trunk/NEMO/OPA_SRC/TRA/trasbc.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 873)
+++ trunk/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 888)
@@ -13,6 +13,6 @@
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and active tracers
+   USE sbc_oce         ! surface boundary condition: ocean
    USE dom_oce         ! ocean space domain variables
-   USE ocesbc          ! surface thermohaline fluxes
    USE phycst          ! physical constant
    USE traqsr          ! solar radiation penetration
@@ -32,5 +32,5 @@
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header$ 
+   !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -132,9 +132,9 @@
 #endif
             IF( lk_vvl) THEN
-               zta = ro0cpr * ( qt(ji,jj) - qsr(ji,jj) ) * zse3t &   ! temperature : heat flux
+               zta = ro0cpr * qns(ji,jj) * zse3t &                   ! temperature : heat flux
                 &    - emp(ji,jj) * zsrau * tn(ji,jj,1)  * zse3t     ! & cooling/heating effet of EMP flux
                zsa = 0.e0                                            ! No salinity concent./dilut. effect
             ELSE
-               zta = ro0cpr * ( qt(ji,jj) - qsr(ji,jj) ) * zse3t     ! temperature : heat flux
+               zta = ro0cpr * qns(ji,jj) * zse3t     ! temperature : heat flux
                zsa = emps(ji,jj) * zsrau * sn(ji,jj,1)   * zse3t     ! salinity :  concent./dilut. effect
             ENDIF
Index: trunk/NEMO/OPA_SRC/TRA/trazdf.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/trazdf.F90	(revision 873)
+++ trunk/NEMO/OPA_SRC/TRA/trazdf.F90	(revision 888)
@@ -14,4 +14,6 @@
    USE dom_oce         ! ocean space and time domain variables 
    USE zdf_oce         ! ocean vertical physics variables
+   USE sbc_oce         ! surface boundary condition: ocean
+   USE dynspg_oce
 
    USE trazdf_exp      ! vertical diffusion: explicit (tra_zdf_exp     routine)
@@ -25,6 +27,4 @@
 
    USE phycst
-   USE dynspg_oce
-   USE ocesbc          ! ocean surface boundary condition
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE domvvl          ! variable volume
@@ -47,5 +47,5 @@
    !!----------------------------------------------------------------------
    !!  OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header$ 
+   !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
Index: trunk/NEMO/OPA_SRC/TRD/trdmod.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRD/trdmod.F90	(revision 873)
+++ trunk/NEMO/OPA_SRC/TRD/trdmod.F90	(revision 888)
@@ -12,5 +12,4 @@
    !!   trd_mod_init     : Initialization step
    !!----------------------------------------------------------------------
-   USE phycst                  ! physical constants
    USE oce                     ! ocean dynamics and tracers variables
    USE dom_oce                 ! ocean space and time domain variables
@@ -18,9 +17,10 @@
    USE trdmod_oce              ! ocean variables trends
    USE ldftra_oce              ! ocean active tracers lateral physics
+   USE sbc_oce                 ! surface boundary condition: ocean
+   USE phycst                  ! physical constants
    USE trdvor                  ! ocean vorticity trends 
    USE trdicp                  ! ocean bassin integral constraints properties
    USE trdmld                  ! ocean active mixed layer tracers trends 
    USE in_out_manager          ! I/O manager
-   USE taumod                  ! surface ocean stress
 
    IMPLICIT NONE
@@ -37,5 +37,5 @@
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header$ 
+   !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -124,6 +124,6 @@
                   DO ji = fs_2, fs_jpim1   ! vector opt.
                      ! save the surface forcing momentum fluxes
-                     ztswu(ji,jj) = taux(ji,jj) / ( fse3u(ji,jj,1)*rau0 )
-                     ztswv(ji,jj) = tauy(ji,jj) / ( fse3v(ji,jj,1)*rau0 )
+                     ztswu(ji,jj) = utau(ji,jj) / ( fse3u(ji,jj,1)*rau0 )
+                     ztswv(ji,jj) = vtau(ji,jj) / ( fse3v(ji,jj,1)*rau0 )
                      ! save bottom friction momentum fluxes
                      ikbu   = MIN( mbathy(ji+1,jj  ), mbathy(ji,jj) )
@@ -175,6 +175,6 @@
                DO ji = fs_2, fs_jpim1   ! vector opt.
                   ! save the surface forcing momentum fluxes
-                  ztswu(ji,jj) = taux(ji,jj) / ( fse3u(ji,jj,1)*rau0 )
-                  ztswv(ji,jj) = tauy(ji,jj) / ( fse3v(ji,jj,1)*rau0 )
+                  ztswu(ji,jj) = utau(ji,jj) / ( fse3u(ji,jj,1)*rau0 )
+                  ztswv(ji,jj) = vtau(ji,jj) / ( fse3v(ji,jj,1)*rau0 )
                   ! save bottom friction momentum fluxes
                   ikbu   = MIN( mbathy(ji+1,jj  ), mbathy(ji,jj) )
Index: trunk/NEMO/OPA_SRC/ZDF/zdfkpp.F90
===================================================================
--- trunk/NEMO/OPA_SRC/ZDF/zdfkpp.F90	(revision 873)
+++ trunk/NEMO/OPA_SRC/ZDF/zdfkpp.F90	(revision 888)
@@ -21,8 +21,7 @@
    USE dom_oce         ! ocean space and time domain
    USE zdf_oce         ! ocean vertical physics
+   USE sbc_oce         ! surface boundary condition: ocean
    USE phycst          ! physical constants
-   USE taumod          ! surface stress
    USE eosbn2          ! equation of state
-   USE ocesbc          ! thermohaline fluxes
    USE zdfddm          ! double diffusion mixing
    USE in_out_manager  ! I/O manager
@@ -148,5 +147,5 @@
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL   (2005)
-   !! $Header$ 
+   !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -460,7 +459,7 @@
             zBosol(ji,jj) = grav * zthermal * qsr(ji,jj)
             ! Non radiative surface buoyancy force
-            zBo   (ji,jj) = grav * zthermal * ( qt(ji,jj) - qsr(ji,jj) ) -  grav * zhalin * emp(ji,jj)
+            zBo   (ji,jj) = grav * zthermal * qns(ji,jj) -  grav * zhalin * emp(ji,jj)
             ! Surface Temperature flux for non-local term
-            wt0(ji,jj) = - qt(ji,jj) * ro0cpr * tmask(ji,jj,1)
+            wt0(ji,jj) = - ( qsr(ji,jj) + qns(ji,jj) )* ro0cpr * tmask(ji,jj,1)
             ! Surface salinity flux for non-local term
             ws0(ji,jj) = - ( emp(ji,jj) * sn(ji,jj,1) * rcs ) * tmask(ji,jj,1)
@@ -476,6 +475,6 @@
             zrhos         = rhop(ji,jj,1) + zflageos * rau0 * ( 1. - tmask(ji,jj,1) )  
             ! Friction velocity (zustar), at T-point : LMD94 eq. 2
-            ztx           = 0.5 * ( taux(ji,jj) + taux(ji - 1, jj    ) )
-            zty           = 0.5 * ( tauy(ji,jj) + tauy(ji    , jj - 1) )
+            ztx           = 0.5 * ( utau(ji,jj) + utau(ji - 1, jj    ) )
+            zty           = 0.5 * ( vtau(ji,jj) + vtau(ji    , jj - 1) )
             ztau          = SQRT( ztx * ztx + zty * zty )
             zustar(ji,jj) = SQRT( ztau / ( zrhos +  epsln ) )
Index: trunk/NEMO/OPA_SRC/ZDF/zdftke.F90
===================================================================
--- trunk/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 873)
+++ trunk/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 888)
@@ -31,6 +31,6 @@
    USE dom_oce         ! ocean space and time domain
    USE zdf_oce         ! ocean vertical physics
+   USE sbc_oce         ! surface boundary condition: ocean
    USE phycst          ! physical constants
-   USE taumod          ! surface stress
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE prtctl          ! Print control
@@ -79,5 +79,5 @@
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2006) 
-   !! $Header: /home/opalod/NEMOCVSROOT/NEMO/OPA_SRC/ZDF/zdftke.F90,v 1.16 2007/06/05 10:39:27 opalod Exp $ 
+   !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -99,5 +99,5 @@
       !!                  - ediss / emxl en**(2/3)        ! dissipation
       !!      with the boundary conditions:
-      !!         surface: en = max( emin0,ebb sqrt(taux^2 + tauy^2) )
+      !!         surface: en = max( emin0,ebb sqrt(utau^2 + vtau^2) )
       !!         bottom : en = emin
       !!      -1- The dissipation and mixing turbulent lengh scales are computed
@@ -299,5 +299,5 @@
       ! 2. Surface boundary condition on tke and its eddy viscosity (zmxlm)
       ! -------------------------------------------------
-      ! en(1)   = ebb sqrt(taux^2+tauy^2) / rau0  (min value emin0)
+      ! en(1)   = ebb sqrt(utau^2+vtau^2) / rau0  (min value emin0)
       ! zmxlm(1) = avmb(1) and zmxlm(jpk) = 0.
 !CDIR NOVERRCHK
@@ -305,6 +305,6 @@
 !CDIR NOVERRCHK
          DO ji = fs_2, fs_jpim1   ! vector opt.
-            ztx2 = taux(ji-1,jj  ) + taux(ji,jj)
-            zty2 = tauy(ji  ,jj-1) + tauy(ji,jj)
+            ztx2 = utau(ji-1,jj  ) + utau(ji,jj)
+            zty2 = vtau(ji  ,jj-1) + vtau(ji,jj)
             zesurf = zbbrau * SQRT( ztx2 * ztx2 + zty2 * zty2 )
             en (ji,jj,1) = MAX( zesurf, emin0 ) * tmask(ji,jj,1)
Index: trunk/NEMO/OPA_SRC/cla.F90
===================================================================
--- trunk/NEMO/OPA_SRC/cla.F90	(revision 873)
+++ trunk/NEMO/OPA_SRC/cla.F90	(revision 888)
@@ -19,7 +19,7 @@
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain variables 
+   USE sbc_oce         ! surface boundary condition: ocean
    USE in_out_manager  ! I/O manager
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE ocesbc          ! ocean surface boundary condition (fluxes)
    USE lib_mpp         ! distributed memory computing
 
@@ -48,5 +48,5 @@
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header$ 
+   !! $Id$
    !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
Index: trunk/NEMO/OPA_SRC/cla_div.F90
===================================================================
--- trunk/NEMO/OPA_SRC/cla_div.F90	(revision 873)
+++ trunk/NEMO/OPA_SRC/cla_div.F90	(revision 888)
@@ -18,6 +18,6 @@
    USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
+   USE sbc_oce         ! surface boundary condition: ocean
    USE in_out_manager  ! I/O manager
-   USE ocesbc          ! ocean surface boundary condition (fluxes)
    USE lib_mpp         ! distributed memory computing library
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
@@ -45,5 +45,5 @@
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header$ 
+   !! $Id$
    !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
Index: trunk/NEMO/OPA_SRC/cla_dynspg.F90
===================================================================
--- trunk/NEMO/OPA_SRC/cla_dynspg.F90	(revision 873)
+++ trunk/NEMO/OPA_SRC/cla_dynspg.F90	(revision 888)
@@ -13,7 +13,6 @@
    USE obc_oce         ! Lateral open boundary condition
    USE sol_oce         ! solver variables
+   USE sbc_oce         ! surface boundary condition: ocean
    USE phycst          ! physical constants
-   USE ocesbc          ! ocean surface boundary condition (fluxes)
-   USE flxrnf          ! ocean runoffs
    USE solpcg          ! preconditionned conjugate gradient solver
    USE solsor          ! Successive Over-relaxation solver
@@ -36,5 +35,5 @@
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header$ 
+   !! $Id$
    !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
Index: trunk/NEMO/OPA_SRC/cpl_oce.F90
===================================================================
--- trunk/NEMO/OPA_SRC/cpl_oce.F90	(revision 873)
+++ trunk/NEMO/OPA_SRC/cpl_oce.F90	(revision 888)
@@ -16,5 +16,5 @@
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header$ 
+   !! $Id$
    !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
    !!----------------------------------------------------------------------
@@ -218,5 +218,5 @@
       qsrc           !: solar radiation (w m-2)
 
-#  if defined key_lim3 || defined key_lim3
+#  if defined key_lim3 || defined key_lim2
    REAL(wp), DIMENSION(jpi,jpj) ::   &  !:
       watm        ,    &  !:
